;       Getestet wurde eine mit Turbo-Assembler bersetzte,
;                           mit Turbo-Linker als COM-File gebundene
;                           Version unter DOS 3.3 mit
;                                         MHS 1.1 und
;                                         Nerwork OS Version 6.3
;
;
;  Eigenschaften:
;  Aufruf:
;  			MAILQ Wartezeit Dateispezifikation
;
;  MAILQ  wird resident installiert und testet dann alle 30 Sekunden,
;         ob eine der Spezifikation entsprechende Datei existiert.
;         Falls dies der Fall ist, wird ein Tonsignal ausgegeben,
;         das identisch zum "Mail" - Signal von Framework III ist.
;         Nach der Ausgabe des Tonsignales wird vor dem nchsten Test
;         eine einstellbare Zeit gewartet.
;         Falls das angegeben Directory nicht existiert oder z.B. der
;         Zugriff ber Netzwerk nicht mglich ist, wird der nchste Test
;         erst nach einer Stunde druchgefhrt. Vorher wird fnf Sekunden
;         lang ein hlicher Brummton ausgegeben.
;
;  Durch einen erneuten Aufruf "MAILQ Dateispezufikation" wird Mailq
;  deaktiviert und wenn mglich aus dem Speicher entfernt.
;
;  im Zusammenhang mit MHS wird MAILQ am besten mittels einer Batch-Datei
;  aufgerufen, die die Dateispezifikation entsprechend der MHS und FW III
;  Systemvariablen MV und BENUTZER automatisch erzeugt:
;  z.B.: ACTMAIL.BAT:
;                   mailq 1 %mv%mhs\mail\users\%benutzer%\fwmail\*.
;  Die Wartezeit 1..9 oder 0 wird in 5 Minuten DSchritten angegeben,
;  jedoch bedeutet 0 50 Minuten
;
;  (der Punkt am Ende der Dateispezifikation ist wichtig, da die MAIL-Dateien
;  im Gegensatz zuden FLAG-Dateien keine Exension haben.)
;  Dann wird alle 30 Sekunden in der MHS-Postbox des Benutzers nachgesehen,
;  ob Post fr den Benutzer angekommen ist.
;  Am Besten wird MAILQ natrlich schon mit AUTOEXEC.BAT aktiviert.
;
;  MAILQ bentigt 1K Speicherplatz und scheint mit allen Programmen
;  (auch Grafik) vertrglich zu sein und mit allen Netzwerken laufen, da
;  nur Standard - DOS - Dateiaufrufe verwendet werden.
;
;  Alle 30 Sekunden bentigt MAILQ etwas Rechnezeit, die dem vom Benutzer
;  bearbeiteten Vordergrundprogramm entzogen wird. Diese Zeit ist aber bei
;  den meisten Netzwerksystemen so kurz, da sie kaum bemerkt wird.
;
;  ACHTUNG: Falls der Zugriff ber das Netzwerk nicht mglich ist, bentigt
;  das Betriebssystem meist etliche Sekunden, bevor dieser Zustand an das
;  Anwenderprogramm (MAILQ) gemeldet wird. Whrend dieser Zeit ist der
;  Rechner (das vom Benutzer bearbeitete Vordergrundprogramm) blockiert.
;  Nach dieser Zeit kann aber normal weitergearbeitet werden, da der nchte
;  Test erst nach einer Stunde erfolgt.


.SALL
DIFFZEIT	=	540     ; TEST ALLE 30 SEK
DIFFZEIT2	=	0FFFFH  ; 60 MIN
DIFFZEIT3       =       5400    ; WIEDERHOLUNGSPIEPSEN ALLE 5 MINUTEN
SOUNDZEIT	=	2
SOUNDZERR	=	90      ; 5 SEKUNDEN
SOUNDH          =	0E21H   ; HOHER TON
SOUNDL          =	0FDDH   ; TIEFER TON
ERRSOUND	=       4000H   ; BRUMMTON

ENVIRON		=	2CH     ; ZEIGER AUF ENVIRONMENT
PAR1		=	060H	; PARAMETER AUF PSP:60H (60H LANG)
DTAOFFS		=	0A0H	; DTA AUF PSP:0A0H (40H LANG)

CTC             =       42H
CTCCTRL         =       43H
TONONOFF        =       61H

DOSCALL	MACRO	DOSFUNCNUM
	MOV	AH,DOSFUNCNUM	; AH = FUNCTION NUMBER
	INT	21H		; CALL DOS
	ENDM

SETPTR	MACRO	P, S, O
	MOV	P.OFST,	O	; SET OFFSET
	MOV	P.SEGM,	S	; SET SEGMENT
	ENDM

GETVECT	MACRO	VECT		; INTERRUPT-VEKTOR VECT -> ES,BX
        MOV     AL,VECT
        DOSCALL 35H
        ENDM


SETVECT	MACRO	VECT            ; INTERRUPT-VEKTOR VECT <- DS,DX
	MOV     AL,VECT
	DOSCALL	25H
	ENDM

POINTER	STRUC
	OFST	DW	0
	SEGM	DW	0
POINTER	ENDS

CODE	SEGMENT	DWORD PUBLIC

	ASSUME	CS:CODE,DS:NOTHING

        ORG     100H
MAIN:
        JMP     TRANSIENT

ACTNR		DB      ?	; WAS IST ZU TUN ?
INUSE1         	POINTER	<>	; <> 0 FALLS DOS IN USE
INUSE2 		POINTER	<>	; <> 0 FALLS DOS IN USE (ALTERNATIV)
ALTINT08	POINTER	<>	; ALTER INT $08 HANDLER - ADRESSE (CLOCK)
ALTINT28	POINTER	<>	; ALTER INT $28 HANDLER - ADRESSE (MULTITASKING)
NEUDTA		POINTER	<>	; DTA IM PSP
ALTSTACK        POINTER <>
ALTINT24        POINTER <>      ; INT 24 ZWISCHENSPEICHER
DNAMEP     	POINTER <>      ; ZEIGER AUF FORMATIERTE DATEISPEC

ZEITZAEHLER 	DW    	?
MEANTIME        DW      ?
SSEGM           DW	?

TEMP		POINTER	<>		; DARF VOM LOKALEN STACK
					; BERSCHRIEBEN WERDEN
		DB    	252 DUP (?)     ; STACK FR DOS-AUFRUF
NEUSTACK:

NOBEEP  PROC    NEAR
        IN      AL,TONONOFF
        AND     AL,0FCH
        OUT     TONONOFF,AL
        RET
NOBEEP  ENDP

BEEPBX  PROC    NEAER
        IN      AL,TONONOFF
        TEST    AL,3
        JNE     NOONOFF
        OR      AL,3
        OUT     TONONOFF,AL
        MOV     AL,0B6H
        OUT     CTCCTRL,AL
NOONOFF:
        MOV     AL,BL
        OUT     CTC,AL
        MOV     AL,BH
        OUT     CTC,AL
        RET
BEEPBX  ENDP

;******************************************************	INT24
INT24:
	MOV	ACTNR,0FFH		; FEHLERKENNUNG
	IRET

;****************************************************** INT28
INT28:
	CMP	ZEITZAEHLER,1
	JE	PT1
	JMP	DWORD PTR ALTINT28

PT1:
	CMP	ACTNR,0
	JE	PA0
	JMP	DWORD PTR ALTINT28

PA0:
	JMP	DOAKTION

;****************************************************** INT8
INT8:
	CLI			; WER WEIS, WAS DER VORGNGERR TUT
	PUSH	AX
	MOV	AX,ZEITZAEHLER
	DEC	AX
	JZ	PT0
	MOV	ZEITZAEHLER,AX
	POP	AX
	JMP	DWORD PTR ALTINT08	; NICHTS ZU TUN

PT0:
	PUSH	BX
	MOV	AL,ACTNR
	CMP	AL,0
	JE	ACT0
	CMP	AL,1
	JE	ACT1
	CMP	AL,2
	JE	ACT2
	CMP	AL,3
	JE	ACT3
	CMP	AL,4
	JE	ACT4
					; HIER DARF ER NIE VORBEIKOMMEN
ENDBXAX:
	POP	BX
	POP	AX
	JMP	DWORD PTR ALTINT08	; JUMP FAR: NICHTS WEITERES TUN


ACT1:
	MOV	BX,SOUNDL
	CALL	BEEPBX
	MOV	AL,2
	MOV	BX,SOUNDZEIT
ALBX:
	MOV	ACTNR,AL
	MOV	ZEITZAEHLER,BX
	JMP	SHORT ENDBXAX

ACT2:
	MOV	BX,SOUNDH
	CALL	BEEPBX
	MOV	AL,3
	MOV	BX,SOUNDZEIT
	JMP	SHORT ALBX

ACT3:
	CALL	NOBEEP
	MOV	AL,0
	MOV     BX,MEANTIME
	JMP	SHORT ALBX

ACT4:					; ENDE FEHLERMELDUNG
	CALL	NOBEEP
	MOV	AL,0
	MOV	BX,DIFFZEIT2
	JMP	SHORT ALBX


ACT0:
	PUSH	DS
	LDS	BX,INUSE1		; DOS IN USE POINTER IN DS:BX
	MOV	AL,[BX]
	LDS	BX,INUSE2		; INUSE 2 FLAG IN DS:BX
	OR	AL,[BX] 		; EINES <> 0 ?
	POP	DS
	JNZ	ENDBXAX			; RETURN FALL DOS-AUFRUF LUFFT

	MOV	ZEITZAEHLER,0FFFFH	; KEIN DOPPELAUFRUF ERLAUBT
	POP	BX
	POP	AX			; NUN SP WIE BEIM AUFRUF
					; SO DASS KEIN STACK VERBRAUCHT WIRD
	POP	TEMP.OFST		; IP DES UNTERBROCHENEN PROGRAMMES
	POP	TEMP.SEGM		; CS DES UNTERBROCHENEN PROGRAMMES
					; FLAGS SIND NOCH AUF DEM STACK
					; VORHER EINGEBUNDENE ROUTINEN AUFRUFEN
	CALL	DWORD PTR ALTINT08      ; IRET HOLT VORDERGRUND FLAGS
	PUSHF				; VORDERGRUND FLAGS ZURCK AUF STACK
	PUSH	TEMP.SEGM		; VORDERGRUND SEGMENT
	PUSH	TEMP.OFST		; VORDERGRUND OFFSET ZURCK
					; NUN SP WIE BEIM AUFRUF
DOAKTION:
	CLI
	SETPTR	ALTSTACK, SS, SP
	MOV	SP,OFFSET NEUSTACK
        MOV     SS,SSEGM
	STI                             ; AB HIER INTERRUPT FREI

	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	DS
	PUSH	ES

	MOV	AL,0
	DOSCALL	51H
	PUSH	BX                      ; PSP VORDERGRUND MERKEN

	MOV	BX,CS                   ; EIGENES PSP
	MOV	AL,0
	DOSCALL	50H

	GETVECT 24H
	SETPTR	ALTINT24,ES,BX

	MOV	DX,OFFSET INT24
	MOV	AX,CS
	MOV	DS,AX
 	SETVECT 24H

	DOSCALL 2FH
	PUSH	ES			; VORDERGRUND DTA MERKEN
	PUSH	BX

	LDS	DX,NEUDTA
	DOSCALL 1AH			; SET OUR DTA

	LDS	DX,DNAMEP
	MOV	CX,0			; NORMALE FILES
	DOSCALL 4EH			; FIND FIRST
	JNC	DATEIDA
	CMP	AL,2
	JE	NODATEI
	CMP	AL,18
	JE	NODATEI
					; Z.B. DIRECTORY GELSCHT ODER
					;      NETZWERKZUGRIFF VERWEIGERT
INT24ERR:				; INT 24 VORAUSGEGEANGEN
	MOV	BX,ERRSOUND
	CALL	BEEPBX
	MOV	ZEITZAEHLER,SOUNDZERR
	MOV	ACTNR,4
	JMP	SHORT DOWEITER

DATEIDA:
	CMP	ACTNR,0FFH		; VORSICHTSHALBER TROTZDEM
	JZ	INT24ERR		; INT 24 TESTEN
	MOV	BX,SOUNDH
	CALL	BEEPBX
	MOV	ACTNR,1
	MOV	ZEITZAEHLER,SOUNDZEIT
	JMP	SHORT DOWEITER

NODATEI:
	CMP	ACTNR,0FFH
	JZ	INT24ERR
	MOV	ZEITZAEHLER,DIFFZEIT
DOWEITER:
	POP	DX
	POP	DS
	DOSCALL 1AH			; SET VORDERGRUND DTA

	LDS	DX,ALTINT24
	SETVECT 24H

	POP	BX			; PSP VORDERGRUND
	MOV	AL,0
	DOSCALL	50H


	POP	ES
	POP	DS
	POP	DX
	POP	CX
	POP	BX
	POP	AX

	CLI
	MOV	SS,ALTSTACK.SEGM
	MOV	SP,ALTSTACK.OFST

	STI
	IRET

TRANSIENT:
	MOV	AX,CS
	MOV	DS,AX
;	MOV     AX,DS:ENVIRON		;das geht auch !!
	MOV	SSEGM,AX

	DOSCALL 30H			; DOS VERSION
	XCHG	AL,AH			; VERSION IN AH, AL
	PUSH	AX
	PUSH	DS
	DOSCALL 34H			; POINTER AUF INUSE FLAG IN ES:BX
	POP	DS
	SETPTR	INUSE1,ES,BX

	POP	AX			; DOSVERSION
	CMP	AX,0200H		; 2.XX ?
	JB	ERR1
	CMP	AX,0300H		; 3.00
	JA	DOS3X
	JB	DOS2

	CMP	BX,019CH		; COMPAQ DOS 3.0?
	JE	VOR			; ZWEITES  FLAG TIEFER
	SUB	BX,01AAH		; MS/PC-DOS 3.0
	JMP	SHORT SET2

ERR1:
	MOV	DX,OFFSET ERRM1
	DOSCALL 9
	JMP	ENDE


DOS2:
	INC	BX			; INUSE 2 HINTER IN-USE
	JMP	SHORT SET2

DOS3X:
	CMP	AX,030AH		; 3.10 ODER GROESSER ?
	JB	SET2			; ????
	CMP	AX,0363H		; FALLS <=, DOS VERSION 3.10-3.99
	JA	SET2 			; >:   INUSE 2 = INUSE

VOR:
	DEC	BX			; INUSE 2 VOR IN-USE

SET2:
	SETPTR	INUSE2, ES, BX		; INUSE 2 ADRESSE

	MOV	AL,0
	DOSCALL 51H			; BX=PSP
	MOV	ES,BX
	SETPTR  DNAMEP,BX,PAR1		; HIER KOMMET DER NAME HIN
	SETPTR	NEUDTA,BX,DTAOFFS	; DTA-ADRESSE  SPEICHERN

	MOV	BX,80H                  ; PARAMER - STRING
	MOV	AL,[ES:BX]
	CMP	AL,5                    ; LENGE PARAMETERSTRING
	JNC	NOERR0
	JMP	ERR0

FEHLER1: JMP    FEHLER11

NOERR0:
        INC     BX
LL1:
        MOV     AL,[ES:BX]
        CMP     AL,' '
        JNE     NOL2
        INC     BX
        JMP     LL1
NOL2:
	CMP     AL,'0'              	; 1. ARG. ZWISCHEN 0 UND 9 ?
        JB      FEHLER1
        CMP     AL,'9'
        JA      FEHLER1
        AND     AL,0FH
        JNE     NONULL
        MOV     AL,10
NONULL:

	XOR     AH,AH
        MOV     CX,DIFFZEIT3
        IMUL    CX
        MOV     MEANTIME,AX

        INC     BX
        MOV     AL,[ES:BX]
	CMP     AL," "
        JE      NOERR01
        JMP     ERR0
NOERR01:
	INC	BX
	MOV	CL,0
	LDS	SI,DNAMEP
LOOP0:
	MOV	AL,[ES:BX]
	CMP	AL," "
	JNZ	LOOP1
	INC	BX
	JMP	LOOP0

LOOP1:
	MOV	AL,[ES:BX]
	CMP	AL,0DH
	JZ	ENDL
	CMP	AL," "
	JZ	ENDL
	MOV	[SI],AL
	INC	BX
	INC	SI
	INC	CL
	JMP	LOOP1
ENDL:
	MOV	AL,0
	MOV	[SI],AL

	LDS	DX,NEUDTA
	DOSCALL 1AH			; SET OUR DTA

	LDS	DX,DNAMEP
	MOV	CX,0			; NORMALE FILES
	DOSCALL 4EH			; FIND FIRST
	JNC	NOERR1
	CMP	AL,2
	JE	NOERR1
	CMP	AL,18
	JE	NOERR1
	JMP	ERRDIR
NOERR1:
					; INTERRUPTS INSTALLIEREN
	MOV	CS:ZEITZAEHLER,0FFFFH	; NOCH KEIN KEIN AUFRUF
	GETVECT 28H
	SETPTR	ALTINT28,ES,BX
	GETVECT 8
	SETPTR	ALTINT08,ES,BX
	MOV	DX,OFFSET INT8
	CMP	DX,BX
	JE	DEINST
	SETVECT 8
	MOV	DX,OFFSET INT28
	SETVECT 28H
	MOV	ACTNR,0
	MOV	ZEITZAEHLER,1		; SOFORT AUFRUFEN

	MOV	DX,OFFSET RESMELD
	DOSCALL 9
	MOV	DX,OFFSET TRANSIENT
	INT	27H			; TERMINATE BUT STAY RESIDENT

DEINST:
					; ES IST CS VOM ALTEN PROGRAMM
	LDS	DX,ES:DWORD PTR ALTINT28; DER GANZ ALTE
	SETVECT 28H
	LDS	DX,ES:DWORD PTR ALTINT08; DER GANZ ALTE
	SETVECT 8
	DOSCALL 49H			; FREE MEM
	MOV	ES,ES:ENVIRON
	DOSCALL 49H			; FREE MEM
	MOV	AX,CS
	MOV	DS,AX
	MOV	DX,OFFSET DEMELD
	DOSCALL 9
	JMP	ENDE

FEHLER11:
        MOV     DX,OFFSET FEHLM1
        DOSCALL 9
        JMP     ENDE

ERRDIR:
	MOV	DX,OFFSET ERRMDIR
	DOSCALL 9
	JMP	ENDE

ERR0:
	MOV	DX,OFFSET ERRM0
	DOSCALL 9

ENDE:	MOV	AL,00H
	DOSCALL 4CH

ERRMDIR DB	0AH,0DH
	DB	"unable to access directory"
	DB	0AH,0DH,"$"
ERRM0	DB	0AH,0DH
	DB	"Usage: MAILQ Wait-Time-Parameter File-Spezifikation"
	DB	0AH,0DH,"$"
ERRM1	DB	0AH,0DH
	DB	"wrong DOS Version"
	DB	0AH,0DH,"$"
RESMELD DB	0AH,0DH
	DB	"MAILQ 2.1 installed (M.Schnell, 1994)"
	DB	0AH,0DH,"$"
DEMELD	DB	0AH,0DH
	DB	"MAILQ deaktivated, memory freed"
	DB	0AH,0DH,"$"
FEHLM1  DB      "Wait-Time-Parameter must be 0 .. 9"
	DB	0AH,0DH,"$"

CODE	ENDS
%NOSYMS
	END	MAIN
